/******************************************************************************
 *
 * Extension of AMDiS - Adaptive multidimensional simulations
 *
 * Copyright (C) 2013 Dresden University of Technology. All Rights Reserved.
 * Web: https://fusionforge.zih.tu-dresden.de/projects/amdis
 *
 * Authors: Simon Praetorius et al.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *
 * See also license.opensource.txt in the distribution.
 * 
 ******************************************************************************/

#ifndef CAHN_HILLIARD_DD_PRECON_H
#define CAHN_HILLIARD_DD_PRECON_H

#include "CahnHilliard.h"

namespace AMDiS { namespace base_problems {
    
class CahnHilliard_DD : public CahnHilliard
{
public: // definition of types

  typedef CahnHilliard super;

public: // public methods

  CahnHilliard_DD(const std::string &name_) : super(name_) { }
  ~CahnHilliard_DD() {};
  
  void setPhase(DOFVector<double>* phase_)
  {
    phase = phase_;
  }

  void fillOperators() override;
  
protected:
  DOFVector<double>* phase;
};
  
} }

#endif // CAHN_HILLIARD_PRECON_DD_H
